{****************************************************************************
 * The Runner Project                                                       *
 * CopyLeft (C) 2005, Runner Team                                           *
 *                                                                          *
 * Runner.pas -  ,          *
 ****************************************************************************}

Program Runner;
Uses
	CRT,
	DOS,
	Graph;
Const
	Xmax = 64;
	Ymax = 48;
	Xmin = 0;
	Ymin = 0;
Type
	Map = Array [1..64, 1..48] of Integer;
Var
	x, y, x1, y1: Integer;
	a: Map;
	s: Integer;
	p: Pointer;
	Ch: Char;
	Left, Rigth, Niz, Verx: Char;
{============================================================================}
Procedure Open_Graph;
Var
	d, m: Integer;
Begin
	d := Detect;
	InitGraph(d, m, '..\Bin');
End;
{============================================================================}
Procedure Open_Map(Var a: Map; s: String);
Var
	i, j: Integer;
	x, y, x2, y2: Integer;
	b: Map;
	f: File of Map;
Begin
	Assign(f, s);
	Reset(f);
	Read(f, b);
	For i := 1 To 64 Do
		For j := 1 To 48 Do
			If b[i, j] = 1 Then
			Begin
				x := (i * 10);
				y := (j * 10);
				x2 := (i * 10) + 10;
				y2 := (j * 10) + 10;
				Bar(x, y, x2, y2)
			End;
	a := b;
	Close(f)
End;
{============================================================================}
Procedure Map_Show(a: Map; x, y, x2, y2: Integer);
Var
	i, j: Integer;
	x1, y1, x3, y3: Integer;
Begin
	For i := x To x2 Do
		For j := y To y2 Do
			If a[i, j] = 1 Then
			Begin
				x1 := (i * 10);
				y1 := (j * 10);
				x3 := (i * 10) + 10;
				y3 := (j * 10) + 10;
				Bar(x1, y1, x3, y3)
			End
End;
{============================================================================}
Procedure DrawLineCub(x, y: Integer);
Begin
	x := x * 10;
	y := y * 10;
	Line(x, y, x + 200, y);
	Line(x + 200, y + 200, x, y + 200);
	Line(x, y + 200, x, y);
	Line(x + 200, y + 200, x + 200, y);
	{Line(x, y, x + 200, y + 200);
	Line(x + 200, y, x, y + 200)}
End;
{============================================================================}
Procedure Game_Option(Var Left, Rigth, Verx, Niz: Char);
Begin
	ClearDevice;
	OutTextXY(270, 185, '<<Game Options>>');
	OutTextXY(270, 200, 'Up:');
	Verx := ReadKey;
	OutTextXY(270, 215, 'Down:');
	Niz := ReadKey;
	OutTextXY(270, 230, 'Left:');
	Rigth := ReadKey;
	OutTextXY(270, 245, 'Right:');
	Left := ReadKey;
	OutTextXY(200, 260, 'Press any key...');
	ReadKey;
	ClearDevice;
	Delay(1000)
End;
{============================================================================}
Procedure Game_Menu(Var Left, Rigth, Verx, Niz: Char);
Var
	Ch: Char;
Begin
	ClearDevice;
	Delay(1000);
	Repeat
		OutTextXY(270, 200, '1. Start game');
		OutTextXY(270, 215, '2. Options');
		OutTextXY(270, 230, '3. Exit');
		Ch := ReadKey;
		If Ch = #50 Then
			Game_Option(Left, Rigth, Verx, Niz);
		If Ch = #51 Then
			Halt
	Until ch = #49;
	ClearDevice;
	OutTextXY(260, 200, 'Press any key...');
	ReadKey;
	ClearDevice;
	Delay(10000)
End;
{============================================================================}
Begin
	Open_Graph;
	Open_Map(a, '..\Map\mainmap.mp');
	x := 1;
	y := 1;
	x1 := 20;
	y1 := 20;
	Left := #100;
	Rigth := #97;
	Verx := #119;
	Niz := #115;
	ClearDevice;
	Game_Menu(Left,Rigth,Verx,Niz);
	Repeat
		Map_Show(a, x, y, x1, y1);
		Circle((x * 10 + 100) + 5, (y * 10 + 100) + 5,5);
		DrawLineCub(x, y);
		Ch := ReadKey;
		If Ch = #27 Then
			Game_Menu(Left, Rigth, Verx, Niz);
		If Ch = Left Then
			If (a[x+11,y+10]=0)and(Xmax>x+11) Then
			begin
				Delay(300);
				ClearDevice;
				x := x + 1;
				x1 := x1 + 1
			End;
		If Ch = Rigth Then
			If (a[x+9,y+10]=0)and(Xmin<x+9) Then
			Begin
				Delay(300);
				ClearDevice;
				x := x - 1;
				x1 := x1 - 1
			End;
		If Ch = Niz Then
			If (a[x+10,y+11]=0)and(Ymax>y+11) Then
			Begin
				Delay(300);
				ClearDevice;
				y := y + 1;
				y1 := y1 + 1
			End;
		If Ch = Verx Then
			If (a[x+10,y+9]=0) and(Ymin<y+9) Then
			Begin
				Delay(300);
				ClearDevice;
				y := y - 1;
				y1 := y1 - 1
			End;
		Delay(300)
	Until 1 = 2
End.