{****************************************************************************
 * The Runner Project                                                       *
 * CopyLeft (C) 2005, Runner Team                                           *
 *                                                                          *
 * R_Config.pas - ,    Runner'               *
 ****************************************************************************}

Unit R_Config;
{============================================================================}
Interface
{============================================================================}
Var
	Config: Record  {:}
		Key: Record  {-:}
			Left: Word;  {--}
			Right: Word; {--}
			Up: Word;    {--}
			Down: Word;  {--}
			Pause: Word; {--}
			Menu: Word   {-- }
		End;
		Dir: Record  {-:}
			Config: String;     {-- }
			Map: String;        {--}
			VideoDriver: String {-- BGI}
		End
	End;

Procedure Configure;
Function GetKey: Word;
Procedure LoadConfig(Name: String);
Procedure SaveConfig(Name: String);

{============================================================================}
Implementation
{============================================================================}
Uses CRT,
     Graph;
{----------------------------------------------------------------------------}
Function GetKey: Word;
{  .   -,  ...}
Var
	Code: Word;
Begin
	Code := Ord(ReadKey);
	If Code = $0000 Then
		Code := Ord(ReadKey)
	Else
		Code := Code shl 8;
	GetKey := Code
End;
{----------------------------------------------------------------------------}
Procedure LoadConfig(Name: String);
{ }
Begin
End;
{----------------------------------------------------------------------------}
Procedure SaveConfig(Name: String);
{ }
Begin
End;
{----------------------------------------------------------------------------}
Procedure Configure;
{ }
Begin
	ClearDevice;
	OutTextXY(270, 185, '<<Game Options>>');
	OutTextXY(270, 200, 'Up:');
	Config.Key.Up := GetKey;
	OutTextXY(270, 215, 'Down:');
	Config.Key.Down := GetKey;
	OutTextXY(270, 230, 'Left:');
	Config.Key.Left := GetKey;
	OutTextXY(270, 245, 'Right:');
	Config.Key.Right := GetKey;
	OutTextXY(270, 260, 'Menu:');
	Config.Key.Menu := GetKey;
	OutTextXY(200, 275, 'Press any key...');
	ReadKey;
	ClearDevice;
	Delay(1000)
End;
{============================================================================}
End.